Public Class Form1
    Private m_Big As Big

    ' Alloctae an object.
    Private Sub btnAllocate_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnAllocate.Click
        m_Big = New Big
        Debug.WriteLine("Allocate: Memory Allocated: " & GC.GetTotalMemory(False))
    End Sub

    ' Release the object.
    Private Sub btnFree_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnFree.Click
        Debug.WriteLine("Freeing object")
        m_Big = Nothing
        Debug.WriteLine("Free: Memory Allocated: " & GC.GetTotalMemory(False))
    End Sub

    ' Force garbage collection.
    Private Sub btnCollect_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnCollect.Click
        GC.Collect()
        Debug.WriteLine("Collect: Memory Allocated: " & GC.GetTotalMemory(False))
    End Sub

    ' Dispose of the object.
    Private Sub btnDispose_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnDispose.Click
        Debug.WriteLine("Disposing object")
        m_Big.Dispose()
        m_Big = Nothing
        Debug.WriteLine("Dispose: Memory Allocated: " & GC.GetTotalMemory(False))
    End Sub
End Class

Public Class Big
    Implements IDisposable

    ' Indicates whether we have already been disposed.
    Private m_WasDisposed As Boolean = False

    ' Dispose of resources.
    Protected Overridable Sub Dispose(ByVal disposing As Boolean)
        If Not m_WasDisposed Then
            If disposing Then
                ' Dispose was called explicitly.
                ' Free managed resources.
                ' TODO: Free the managed resources.
            End If

            ' Free unmanaged resources.
            ' TODO: Free the unmanaged resources.
        End If

        m_WasDisposed = True
    End Sub

    ' Dispose of resources explicitly.
    ' Do not change this code. Make changes
    ' to the other version of Dispose.
    Public Sub Dispose() Implements IDisposable.Dispose
        Dispose(True)
        GC.SuppressFinalize(Me)
    End Sub

    ' Finalize the object.
    Protected Overrides Sub Finalize()
        ' Call Dispose passing False to indicate that
        ' we are not running from a program call to Dispose().
        Dispose(False)
    End Sub
End Class